package UI.GameState;

import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

public class EnemyTank extends TankState {
    public EnemyTank(WallState walls) {
        super(walls);
        myListener.add(new KeyHandler2());
    }

    /**
     * The keyboard handler.
     */
    class KeyHandler2 extends KeyAdapter {

        @Override
        public void keyPressed(KeyEvent e) {

            switch (e.getKeyCode()) {
                case KeyEvent.VK_E:
                    keyE = true;
                    break;
                case KeyEvent.VK_D:
                    keyD = true;
                    break;
                case KeyEvent.VK_S:
                    keyS = true;
                    break;
                case KeyEvent.VK_F:
                    keyF = true;
                    break;
                case KeyEvent.VK_Q:
                    keyQ = true;
                    break;
                case KeyEvent.VK_ESCAPE:
                    gameOver = true;
                    break;
            }
        }

        @Override
        public void keyReleased(KeyEvent e) {
            switch (e.getKeyCode())
            {
                case KeyEvent.VK_E:
                    keyE = false;
                    break;
                case KeyEvent.VK_D:
                    keyD = false;
                    break;
                case KeyEvent.VK_S:
                    keyS = false;
                    break;
                case KeyEvent.VK_F:
                    keyF = false;
                    break;
                case KeyEvent.VK_Q:
                    keyQ = false;
                    break;
            }
        }

    }
}
