package UI.LogIn;

import javax.imageio.ImageIO;
import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.File;
import java.io.IOException;

public class SettingPanel extends JPanel {

    private Setting setting = new Setting();
    private String chosenTankPath ="C:\\Users\\Lenovo\\IdeaProjects\\JTankTrouble\\pics\\tank_blue.png";
    private Image image;

    public SettingPanel() throws IOException {
        setLayout(new GridLayout(1 , 2));
        add(informationPanel());
        add(changeableComponents());
        this.revalidate();
        this.repaint();
    }

    private JPanel informationPanel(){

        JPanel informationPanel  = new JPanel(new GridLayout(6, 1));
        JPanel informationPanel1 = new JPanel();
        JPanel informationPanel2 = new JPanel();
        JPanel informationPanel3 = new JPanel();
        JPanel informationPanel4 = new JPanel();
        JPanel informationPanel5 = new JPanel();
        JPanel informationPanel6 = new JPanel();

        JLabel username= new JLabel("username   ");
        JLabel userName = new JLabel(setting.getUserName());
        JLabel playedTime = new JLabel("played time   ");
        JLabel playedTimeNum = new JLabel(setting.getPlayedTime()+"");
        JLabel winNumSingle1 = new JLabel("Wins(singlePlay)   ");
        JLabel winNumSingle2 = new JLabel(setting.getNumOfWinsSingle()+"");
        JLabel looseNumSingle1 = new JLabel("looses(singlePlay)   ");
        JLabel looseNumSingle2 = new JLabel(setting.getNumOfLoosesSingle()+"");
        JLabel winNumMulti1 = new JLabel("Wins(multiPlay)   ");
        JLabel winNumMulti2 = new JLabel(setting.getNumOfWinsMulti()+"");
        JLabel looseNumMulti1 = new JLabel("Looses(multiPlay   ");
        JLabel looseNumMulti2 = new JLabel(setting.getNumOfLoosesMulti()+"");

        informationPanel1.add(username);
        informationPanel1.add(userName);
        informationPanel2.add(playedTime);
        informationPanel2.add(playedTimeNum);
        informationPanel3.add(winNumSingle1);
        informationPanel3.add(winNumSingle2);
        informationPanel4.add(looseNumSingle1);
        informationPanel4.add(looseNumSingle2);
        informationPanel5.add(winNumMulti1);
        informationPanel5.add(winNumMulti2);
        informationPanel6.add(looseNumMulti1);
        informationPanel6.add(looseNumMulti2);
        informationPanel.add(informationPanel1);
        informationPanel.add(informationPanel2);
        informationPanel.add(informationPanel3);
        informationPanel.add(informationPanel4);
        informationPanel.add(informationPanel5);
        informationPanel.add(informationPanel6);

        return informationPanel;
    }

    private JPanel changeableComponents() throws IOException {
        JPanel changeableComponents = new JPanel(new GridLayout(5 , 1));
        JPanel changeableComponents1 = new JPanel();
        JPanel changeableComponents2 = new JPanel();
        JPanel changeableComponents3 = new JPanel();
        JPanel changeableComponents4 = new JPanel();
        JLabel playWith= new JLabel("play with");
        String[] options ={"mouth" , "keyboard"};
        JComboBox comboBox = new JComboBox(options);
        JLabel urls = new JLabel("URL");
        String[] options2 ={""};
        JComboBox comboBox2 = new JComboBox(options2);
        JLabel tankColor = new JLabel("tank's color");
        String[] options3 ={"blue" , "green" ,"white"};
        JComboBox comboBox3 = new JComboBox(options3);
        image = ImageIO.read(new File(chosenTankPath));
        ImageIcon imageIcon = new ImageIcon(image);
        JLabel tankShape = new JLabel(imageIcon);
        changeableComponents.removeAll();
        changeableComponents4.add(tankShape);
        comboBox3.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                String s = (String) comboBox3.getSelectedItem();
                switch (s){
                    case "blue" : {chosenTankPath = "C:\\Users\\Lenovo\\IdeaProjects\\JTankTrouble\\pics\\tank_blue.png";break;}
                    case "green" : {chosenTankPath = "C:\\Users\\Lenovo\\IdeaProjects\\JTankTrouble\\pics\\tank_green.png";break;}
                    case "white" : chosenTankPath = "C:\\Users\\Lenovo\\IdeaProjects\\JTankTrouble\\pics\\tank_sand.png";
                }

                try {
                    image = ImageIO.read(new File(chosenTankPath));
                } catch (IOException ex) {
                    ex.printStackTrace();
                }
                SettingPanel.this.revalidate();
                SettingPanel.this.repaint();
                setting.setTankShapePath(chosenTankPath);
                changeableComponents4.removeAll();
                ImageIcon imageIcon = new ImageIcon(image);
                JLabel tankShape = new JLabel(imageIcon);
                changeableComponents4.add(tankShape);
            }
        });
        JButton back = new JButton("back");
        back.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
                super.mouseClicked(e);
                removeAll();
                try {
                    MainPanel mainPanel = new MainPanel();
                    add(mainPanel);
                } catch (IOException ex) {
                    ex.printStackTrace();
                }
                SettingPanel.this.revalidate();
                SettingPanel.this.repaint();
            }
        });

        changeableComponents1.add(playWith);
        changeableComponents1.add(comboBox);
        changeableComponents2.add(urls);
        changeableComponents2.add(comboBox2);
        changeableComponents3.add(tankColor);
        changeableComponents3.add(comboBox3);
        changeableComponents.add(changeableComponents1);
        changeableComponents.add(changeableComponents2);
        changeableComponents.add(changeableComponents3);
        changeableComponents.add(changeableComponents4);
        changeableComponents.add(back);
        return changeableComponents;
    }
}

